CMSIS-DSP: Complex-by-Complex Multiplication

| CMSIS-DSP Version 1.4.7 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Complex-by-Complex Multiplication
Complex Math Functions

## Functions
void | arm_cmplx_mult_cmplx_f32 (float32_t *pSrcA, float32_t *pSrcB, float32_t *pDst, uint32_t numSamples)
| Floating-point complex-by-complex multiplication.
void | arm_cmplx_mult_cmplx_q15 (q15_t *pSrcA, q15_t *pSrcB, q15_t *pDst, uint32_t numSamples)
| Q15 complex-by-complex multiplication.
void | arm_cmplx_mult_cmplx_q31 (q31_t *pSrcA, q31_t *pSrcB, q31_t *pDst, uint32_t numSamples)
| Q31 complex-by-complex multiplication.

## Description

Multiplies a complex vector by another complex vector and generates a complex result. The data in the complex arrays is stored in an interleaved fashion (real, imag, real, imag, ...). The parameter `numSamples` represents the number of complex samples processed. The complex arrays have a total of `2*numSamples` real values.

The underlying algorithm is used:

    for(n=0; n<numSamples; n++) {
        pDst[(2*n)+0] = pSrcA[(2*n)+0] * pSrcB[(2*n)+0] - pSrcA[(2*n)+1] * pSrcB[(2*n)+1];
        pDst[(2*n)+1] = pSrcA[(2*n)+0] * pSrcB[(2*n)+1] + pSrcA[(2*n)+1] * pSrcB[(2*n)+0];
    }

There are separate functions for floating-point, Q15, and Q31 data types.

## Function Documentation

void arm_cmplx_mult_cmplx_f32 | ( | float32_t * | pSrcA,
|  | float32_t * | pSrcB,
|  | float32_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | numSamples | number of complex samples in each vector

Returns
  none.

Examples:
  arm_convolution_example_f32.c.

Referenced by main().

void arm_cmplx_mult_cmplx_q15 | ( | q15_t * | pSrcA,
|  | q15_t * | pSrcB,
|  | q15_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | numSamples | number of complex samples in each vector

Returns
  none.

Scaling and Overflow Behavior:

  The function implements 1.15 by 1.15 multiplications and finally output is converted into 3.13 format.

void arm_cmplx_mult_cmplx_q31 | ( | q31_t * | pSrcA,
|  | q31_t * | pSrcB,
|  | q31_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | numSamples | number of complex samples in each vector

Returns
  none.

Scaling and Overflow Behavior:

  The function implements 1.31 by 1.31 multiplications and finally output is converted into 3.29 format. Input down scaling is not required.

Referenced by arm_dct4_q31().